// MyDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ForMarianne.h"
#include "MyDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CMyDlg dialog

CMyDlg::CMyDlg(CWnd* pParent /*=NULL*/)
	: CExtNCW < CExtResizableDialog > ( CMyDlg::IDD, pParent )
{
	//{{AFX_DATA_INIT(CMyDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMyDlg::DoDataExchange(CDataExchange* pDX)
{
	CExtNCW < CExtResizableDialog > :: DoDataExchange( pDX );
	//{{AFX_DATA_MAP(CMyDlg)
	DDX_Control(pDX, IDC_CHECK1, m_chkColorize);
	DDX_Control(pDX, ID_FILE_PRINT_PREVIEW, m_btnPreview);
	DDX_Control(pDX, IDOK, m_btnOK);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_MY_GRID, m_wndGrid);
}

BEGIN_MESSAGE_MAP( CMyDlg, CExtResizableDialog )
	//{{AFX_MSG_MAP(CMyDlg)
	ON_COMMAND( ID_FILE_PRINT_PREVIEW, OnPreview )
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyDlg message handlers

BOOL CMyDlg::OnInitDialog()
{
	CExtNCW < CExtResizableDialog > :: OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	m_wndGrid.FrozenColumnCountLeftSet( 1L, false );
	m_wndGrid.FrozenColumnCountRightSet( 3L, false );
	m_wndGrid.FrozenRowCountTopSet( 2L, false );
	m_wndGrid.FrozenRowCountBottomSet( 2L, false );
	m_wndGrid.OuterRowCountTopSet( 2, false );
	m_wndGrid.OuterRowCountBottomSet( 1, false );
	m_wndGrid.OuterColumnCountLeftSet( 1, false );
	m_wndGrid.OuterColumnCountRightSet( 1, false );
const int nDemoColumnCount = 20;
const int nDemoRowCount = 20;
	m_wndGrid.ColumnAdd( nDemoColumnCount, false );
	m_wndGrid.RowAdd( nDemoRowCount, false );
	m_wndGrid.SiwModifyStyle(
		__ESIS_STH_PIXEL|__ESIS_STV_PIXEL
		//__ESIS_STH_ITEM|__ESIS_STV_ITEM
			|__EGBS_SFM_CELLS_HV|__EGBS_MULTI_AREA_SELECTION
				|__EGBS_LBEXT_SELECTION|__EGBS_SUBTRACT_SEL_AREAS
				|__EGBS_NO_HIDE_SELECTION
			|__EGBS_GRIDLINES
			|__EGBS_DYNAMIC_RESIZING|__EGBS_RESIZING_CELLS_OUTER
				//|__EGBS_RESIZING_CELLS_INNER
				//|__EGBS_FIXED_SIZE_ROWS
			|__EGBS_SF_SELECT_OUTER_COLUMNS|__EGBS_SF_SELECT_OUTER_ROWS
			,
		0,
		false
		);
	m_wndGrid.BseModifyStyle(
		__EGWS_BSE_BUTTONS_IN_HOVERED_CELL
			|__EGWS_BSE_BUTTONS_IN_HOVERED_COLUMN
			|__EGWS_BSE_BUTTONS_IN_HOVERED_ROW
			,
		__EGWS_BSE_BUTTONS_PERSISTENT, // __EGWS_BSE_EDIT_AUTO
		false
		);
	m_wndGrid.HoverEventsSet( true, true );
	m_wndGrid.HoverHighlightSet();

CRect rcFrozenRange = m_wndGrid.OnSiwGetFrozenRange();
CExtGridCell * pCell;
CString s;
	for( int x = 0; x < nDemoColumnCount; x++ )
	{
		pCell = m_wndGrid.GridCellGetOuterAtTop( x, 0, RUNTIME_CLASS(CExtGridCellHeader) );
		ASSERT_VALID( pCell );
		s.Format( _T("T-%d"), x );
		pCell->TextSet( s );
		int nExtent = 55;
		pCell->ExtentSet( nExtent );
		//pCell->ExtentSet( nExtent, -1 );
		//pCell->ExtentSet( nExtent, 1 );
// pCell->ExtraSpaceSet( 10, true );
// pCell->ExtraSpaceSet( 10, false );

		pCell = m_wndGrid.GridCellGetOuterAtTop( x, 1, RUNTIME_CLASS(CExtGridCellHeader) );
		ASSERT_VALID( pCell );
		s.Format( _T("T-%d"), x );
		pCell->TextSet( s );

		pCell = m_wndGrid.GridCellGetOuterAtBottom( x, 0, RUNTIME_CLASS(CExtGridCellHeader) );
		ASSERT_VALID( pCell );
		s.Format( _T("B-%d"), x );
		pCell->TextSet( s );

		for( int y = 0; y < nDemoRowCount; y++ )
		{
			pCell = m_wndGrid.GridCellGetOuterAtLeft( 0, y, RUNTIME_CLASS(CExtGridCellHeader) );
			ASSERT_VALID( pCell );
			s.Format( _T("L-%d"), y );
			pCell->TextSet( s );
// pCell->ExtraSpaceSet( 10, true );
// pCell->ExtraSpaceSet( 10, false );

			pCell = m_wndGrid.GridCellGetOuterAtRight( 0, y, RUNTIME_CLASS(CExtGridCellHeader) );
			ASSERT_VALID( pCell );
			s.Format( _T("R-%d"), y );
			pCell->TextSet( s );

			LPTSTR sF = _T("i");
			if( x < rcFrozenRange.left )
				sF = _T("fl");
			else if( x >= ( nDemoColumnCount - rcFrozenRange.right ) )
				sF = _T("fr");

			if( y < rcFrozenRange.top )
			{
				sF = _T("ft");
				if( x < rcFrozenRange.left )
					sF = _T("ftl");
				else if( x >= ( nDemoColumnCount - rcFrozenRange.right ) )
					sF = _T("ftr");
			}
			else if( y >= ( nDemoRowCount - rcFrozenRange.bottom ) )
			{
				sF = _T("fb");
				if( x < rcFrozenRange.left )
					sF = _T("fbl");
				else if( x >= ( nDemoColumnCount - rcFrozenRange.right ) )
					sF = _T("fbr");
			}

// 			pCell =  m_wndGrid.GridCellGet( x, y, 0, 0, RUNTIME_CLASS(CExtGridCellString) );
// 			ASSERT_VALID( pCell );
// 			s.Format( _T("%s-%d-%d"), sF, x, y );
// 			pCell->TextSet( s );

			CExtGridCellComboBox * pCellCombo = (CExtGridCellComboBox *)
				m_wndGrid.GridCellGet( x, y, 0, 0, RUNTIME_CLASS(CExtGridCellComboBox) );
			ASSERT_VALID( pCellCombo );
			s.Format( _T("%s-%d-%d"), sF, x, y );
			pCellCombo->TextSet( s );
			pCellCombo->AddString( s );
			for( int k = 0; k < 26; k++ )
			{
				s.Format( _T("%c"), _T('A') + k );
				pCellCombo->AddString( s );
			}
			pCellCombo->ModifyStyle( __EGCS_NO_INPLACE_CONTROL );
		}
	}

	pCell = m_wndGrid.GridCellGet( 0, 0, -1, -1, RUNTIME_CLASS(CExtGridCellHeader) );
	ASSERT_VALID( pCell );
	pCell->TextSet( _T("TL") );
	pCell = m_wndGrid.GridCellGet( 0, 0, +1, -1, RUNTIME_CLASS(CExtGridCellHeader) );
	ASSERT_VALID( pCell );
	pCell->TextSet( _T("TR") );
	pCell = m_wndGrid.GridCellGet( 0, 0, -1, +1, RUNTIME_CLASS(CExtGridCellHeader) );
	ASSERT_VALID( pCell );
	pCell->TextSet( _T("BL") );
	pCell = m_wndGrid.GridCellGet( 0, 0, +1, +1, RUNTIME_CLASS(CExtGridCellHeader) );
	ASSERT_VALID( pCell );
	pCell->TextSet( _T("BR") );

m_wndGrid.GridCellJoinSet(CSize(1,2), 0, 0, 0, -1);
	
	m_wndGrid.OnSwUpdateScrollBars();
	m_wndGrid.FocusSet( CPoint(0,0) );

	m_chkColorize.SetCheck( m_wndGrid.m_bColorizedMode ? 1 : 0 );

	AddAnchor( IDC_MY_GRID, __RDA_LT, __RDA_RB );
	AddAnchor( IDOK, __RDA_RT );
	AddAnchor( ID_FILE_PRINT_PREVIEW, __RDA_RT );
	AddAnchor( IDC_CHECK1, __RDA_RT );
	SetMinTrackSize( CSize(50,50) );
	EnableSaveRestore( _T("dummy"), _T("dummy") );
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMyDlg::OnPreview()
{
	m_wndGrid.OnCmdMsg( ID_FILE_PRINT_PREVIEW, CN_COMMAND, NULL, NULL );
}

void CMyDlg::OnCheck1() 
{
	m_wndGrid.m_bColorizedMode = m_chkColorize.GetCheck() ? true : false;
	m_wndGrid.OnSwDoRedraw();
}
